;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of PENGUIN CROSS 
;;  Copyright (C) 2020 Francesc Bellido Delgado
;;  Copyright (C) 2020 David Mulero Pérez
;;  Copyright (C) 2020 Wei He
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "controls_man.h.s"
.include "system/input_sys.h.s"
.include "state_man.h.s"
.include "system/render_sys.h.s"
.include "../cpct_functions.h.s"
.include "template_man.h.s"

string_ingame:
	.asciz "IN GAME"

string_inmenu:
	.asciz "IN MENU"

string_returntomenu:
	.asciz "RETURN TO MENU"

controls_man_play:

	;Bucle	
	call controls_man_render_design

  controls_man_play_loop:
	 
	 call input_sys_controls_update	

	 ;Si el state ha variado volvemos al bucle de state_man
	 call state_man_getStatus
	 cp #state_controls
	 ret nz

  	 jr  controls_man_play_loop

	ret

controls_man_render_design:

	;FONDO AZUL
	ld de, #0xC000
  ld a, #0x3C
  ld c, #64
  ld b, #256
  call render_sys_drawSolidBox

  ;;FLECHA ARRIBA DE PERSONAJE
  ld hl, #_spr_flecha_0
  ld de, #0xC120
  ld  c, #Width4
  ld  b, #Height8
  call render_sys_drawSprite

  ;;PINGÜINO
  ld hl, #_spr_penguin_0
  ld de, #0xE15E
  ld  c, #Width8
  ld  b, #Height16
  call render_sys_drawSpriteMask

  ;;FLECHA DERECHA DE PERSONAJE
  ld hl, #_spr_flecha_1
  ld de, #0xF167
  ld  c, #Width4
  ld  b, #Height8
  call render_sys_drawSprite

  ;;FLECHA IZQUIERDA DE PERSONAJE
  ld hl, #_spr_flecha_3
  ld de, #0xF159
  ld  c, #Width4
  ld  b, #Height8
  call render_sys_drawSprite

  ;;FLECHA ABAJO DE PERSONAJE
  ld hl, #_spr_flecha_2
  ld de, #0xCA20
  ld  c, #Width4
  ld  b, #Height8
  call render_sys_drawSprite

  ;;TECLA Q IN GAME
  ld hl, #_spr_letraq
  ld de, #0xC2C6
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;;TECLA A IN GAME
  ld hl, #_spr_letraa
  ld de, #0xC346
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;;TECLA O IN GAME
  ld hl, #_spr_letrao
  ld de, #0xC34E
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;TECLA P IN GAME
  ld hl, #_spr_letrap
  ld de, #0xC354
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;;JOYSTICK IN GAME
  ld hl, #_spr_joystick
  ld de, #0xC360
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;;FLECHA ARRIBA IN GAME
  ld hl, #_spr_teclaflecha_0
  ld de, #0xC2F0
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;;FLECHA ABAJO IN GAME
  ld hl, #_spr_teclaflecha_2
  ld de, #0xC370
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;;FLECHA DERECHO IN GAME
  ld hl, #_spr_teclaflecha_1
  ld de, #0xC335
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;;FLECHA IZQUIERDA DE PERSONAJE
  ld hl, #_spr_teclaflecha_3
  ld de, #0xC32B
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;;JOYSTICK IN MENU
  ld hl, #_spr_joystick
  ld de, #0xC4E0
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;;FLECHA ARRIBA IN MENU
  ld hl, #_spr_teclaflecha_0
  ld de, #0xCC8A
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;;FLECHA ABAJO IN MENU
  ld hl, #_spr_teclaflecha_2
  ld de, #0xCD0A
  ld  c, #Width5
  ld  b, #Height10
  call render_sys_drawSprite

  ;;TECLA Q IN MENU
  ld hl, #_spr_letraq
  ld de, #0xCC91
	ld  c, #Width5
	ld  b, #Height10
	call render_sys_drawSprite

 	;;TECLA A IN MENU
 	ld hl, #_spr_letraa
	ld de, #0xCD11
	ld  c, #Width5
	ld  b, #Height10
  call render_sys_drawSprite

  ;;INTRO 
  ld hl, #_spr_intro
  ld de, #0xC4B0
  ld  c, #Width6
  ld  b, #Height16
  call render_sys_drawSprite

  ;;ESPACIO
  ld hl, #_spr_space
  ld de, #0xC56C
  ld  c, #Width15
  ld  b, #Height8
  call render_sys_drawSprite

  ;;ESCAPE
  ld hl, #_spr_escape
  ld de, #0xC6DE
  ld  c, #Width11
  ld  b, #Height10
  call render_sys_drawSprite

  ;STRING IN GAME
  ld    h, #6 ;D = Background PEN (0)
  ld    l, #9 ;D = Foreground PEN (0)
  call cpct_setDrawCharM0_asm  
  ld c, #0x12 ;Coordenada X
  ld b, #0x10 ;Coordenada Y
  ld de, #0xC000 
  call render_sys_getScreenPointer     
  ld   iy, #string_ingame   ;Puntero a la string
  call myDrawStringM0  ;Dibuja la string

  ;;STRING IN MENU
  call cpct_setDrawCharM0_asm  
  ld c, #0x12 ;Coordenada X
  ld b, #0x80 ;Coordenada Y
  ld de, #0xC000
  call render_sys_getScreenPointer     
  ld   iy, #string_inmenu ;Puntero a la string
  call myDrawStringM0  ;Dibuja la string

  ;;STRING RETURN TO MENU
  call cpct_setDrawCharM0_asm  
  ld c, #0x05 ;Coordenada X
  ld b, #0xC0 ;Coordenada Y
  ld de, #0xC000
  call render_sys_getScreenPointer     
  ld   iy, #string_returntomenu ;Puntero a la string
  call myDrawStringM0  ;Dibuja la string

	ret
