;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of PENGUIN CROSS 
;;  Copyright (C) 2020 Francesc Bellido Delgado
;;  Copyright (C) 2020 David Mulero Pérez
;;  Copyright (C) 2020 Wei He
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "credits_man.h.s"
.include "system/input_sys.h.s"
.include "state_man.h.s"
.include "system/render_sys.h.s"
.include "../cpct_functions.h.s"
.include "template_man.h.s"

string_developedby:
        .asciz "DEVELOPED BY"

string_cuboidstudio:
        .asciz "CUBOID STUDIO"

string_francesc:
        .asciz "FRANCESC"

string_bellido:
        .asciz "BELLIDO"

string_david:
        .asciz "DAVID"

string_mulero:
        .asciz "MULERO"

string_wei:
        .asciz "WEI HE"

credits_man_play:

        ;Bucle  
        call credits_man_render_design

  credits_man_play_loop:
         
        call input_sys_controls_update        

        ;Si el state ha variado volvemos al bucle de state_man
        call state_man_getStatus
        cp #state_credits
        ret nz

        jr  credits_man_play_loop

        ret

credits_man_render_design:       

    ;FONDO AZUL
    ld de, #0xC000
    ld a, #0x3C
    ld c, #64
    ld b, #256
    call render_sys_drawSolidBox

    ;;STRING DEVELOPED BY
    call cpct_setDrawCharM0_asm  
    ld c, #0x08 ;Coordenada X
    ld b, #0x1A ;Coordenada Y
    ld de, #0xC000 
    call render_sys_getScreenPointer     
    ld   iy, #string_developedby   ;Puntero a la string
    call myDrawStringM0  ;Dibuja la string

    ;;LOGO
    ld hl, #_spr_logo
    ld de, #0xC297
    ld  c, #Width17
    ld  b, #Height34
    call render_sys_drawSprite

    ;;STRING CUBOID STUDIO
    call cpct_setDrawCharM0_asm  
    ld c, #0x06 ;Coordenada X
    ld b, #0x2A ;Coordenada Y
    ld de, #0xC000 
    call render_sys_getScreenPointer     
    ld   iy, #string_cuboidstudio   ;Puntero a la string
    call myDrawStringM0  ;Dibuja la string

    ;;STRING FRANCESC
    call cpct_setDrawCharM0_asm  
    ld c, #0x10 ;Coordenada X
    ld b, #0x90 ;Coordenada Y
    ld de, #0xC000
    call render_sys_getScreenPointer     
    ld   iy, #string_francesc ;Puntero a la string
    call myDrawStringM0  ;Dibuja la string

    ;;STRING BELLIDO
    call cpct_setDrawCharM0_asm  
    ld c, #0x12 ;Coordenada X
    ld b, #0x9A ;Coordenada Y
    ld de, #0xC000
    call render_sys_getScreenPointer     
    ld   iy, #string_bellido ;Puntero a la string
    call myDrawStringM0  ;Dibuja la string

    ;;STRING DAVID
    call cpct_setDrawCharM0_asm  
    ld c, #0x15 ;Coordenada X
    ld b, #0xBA ;Coordenada Y
    ld de, #0xC000
    call render_sys_getScreenPointer     
    ld   iy, #string_david ;Puntero a la string
    call myDrawStringM0  ;Dibuja la string

    ;;STRING MULERO
    call cpct_setDrawCharM0_asm  
    ld c, #0x13 ;Coordenada X
    ld b, #0xC3 ;Coordenada Y
    ld de, #0xC000
    call render_sys_getScreenPointer     
    ld   iy, #string_mulero ;Puntero a la string
    call myDrawStringM0  ;Dibuja la string

    ;;STRING WEI
    call cpct_setDrawCharM0_asm  
    ld c, #0x14 ;Coordenada X
    ld b, #0xE2 ;Coordenada Y
    ld de, #0xC000
    call render_sys_getScreenPointer     
    ld   iy, #string_wei ;Puntero a la string
    call myDrawStringM0  ;Dibuja la string

    ret
