;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of PENGUIN CROSS 
;;  Copyright (C) 2020 Francesc Bellido Delgado
;;  Copyright (C) 2020 David Mulero Pérez
;;  Copyright (C) 2020 Wei He
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;;
;;Entity Manager
;; 

;;Rutinas globales
.globl entity_man_init
.globl entity_man_create
.globl entity_man_set4destroy
.globl entity_man_update
.globl entity_man_destroy_one
.globl entity_man_forAll
.globl entity_man_forAllMatching2
.globl entity_man_decrementarContador
.globl entity_man_get_last_entity
.globl entity_man_get_entity_array
.globl entity_man_forPlayerAndAll
.globl entity_man_resetJugador	
.globl entity_man_reset
.globl entity_man_getPlayer
.globl entity_man_reset_huron
.globl entity_man_resetPlayerLastPtr

;;Constantes
entity_size  = 20
max_entities = 50

;;Constantes que indican el orden de los atributos de cada entidad
e_type 	    = 0
e_comp 	    = 1
e_x	 	    = 2
e_y   	    = 3
e_vx  	    = 4
e_vy   	    = 5
e_w    	    = 6
e_h    	    = 7
e_sprite 	    = 8
e_lastPtr       = 10
e_lastPtr2      = 12
e_contador 	    = 14
e_constContador = 15
e_fila          = 16
e_behaviour     = 17
e_auxiliar	    = 19

;;Type of entity
type_invalid 	= 0x00
type_default 	= 0x01
type_player 	= 0x02
type_enemigo 	= 0x04
type_meta   	= 0x08
type_item    	= 0x10
type_plataforma  	= 0x40
type_destroy  	= 0x80

;;Component of entity
cmp_render	 = 0x01
cmp_movable  = 0x02
cmp_colider  = 0x04
cmp_haveIA	 = 0x08
cmp_control  = 0x10


