;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of PENGUIN CROSS 
;;  Copyright (C) 2020 Francesc Bellido Delgado
;;  Copyright (C) 2020 David Mulero Pérez
;;  Copyright (C) 2020 Wei He
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "template_man.h.s"
.include "entity_man.h.s"
.include "system/ia_sys.h.s"

;Template
player_template:
	.db	type_player								;type
	.db	cmp_render | cmp_control | cmp_colider | cmp_movable	;comp
	.db	0x20, 0xE0								;x, y
	.db	0x00, 0x00								;vx, vy
	.db	Width8, Height16							;w, h
	.dw	_spr_penguin_0							;sprite
	.db	0x00, 0x70								;lastPtr 
	.db	0x00, 0x70								;lastPtr 2
	.db   0x00									;contador
	.db   0x00									;constcont
	.db   0x00									;fila
	.dw   0x0000								;behaviour
	.db   0x00									;auxiliar

enemigo1_template:
	.db	type_enemigo							;type
	.db	cmp_render |  cmp_colider | cmp_movable | cmp_haveIA	;comp
	.db	0x0, 0xD0								;x, y
	.db	0x01, 0x00								;vx, vy
	.db	Width12, Height16							;w, h
	.dw	_spr_enemigo_0							;sprite
	.db	0x00, 0x70								;lastPtr 
	.db	0x00, 0x70								;lastPtr 2
	.db   0x05									;contador
	.db   0x0A									;constcont
	.db   0x01									;fila
	.dw   ia_sys_behaviour_LeftOrRight					;behaviour
	.db   0x00									;auxiliar

meta_template:
	.db	type_meta								;type
	.db	cmp_colider | cmp_render			   		;comp
	.db	0x08, 0x10								;x, y
	.db	0x00, 0x00								;vx, vy
	.db	Width8, Height16							;w, h
	.dw	_spr_igloo								;sprite
	.db	0x00, 0x70								;lastPtr
	.db	0x00, 0x70								;lastPtr 2
	.db   0x00									;contador
	.db   0x00									;constcont
	.db   0x0D									;fila
	.dw   0x0000								;behaviour
	.db   0x00									;auxiliar

plataforma_template:
	.db	type_plataforma							;type
	.db	cmp_render | cmp_movable | cmp_colider | cmp_haveIA	;comp
	.db	0x00, 0x16								;x, y
	.db	0x01, 0x00								;vx, vy
	.db	Width16, Height16							;w, h
	.dw	_spr_hielo								;sprite
	.db	0x00, 0x70								;lastPtr 
	.db	0x00, 0x70								;lastPtr 2
	.db   0x05									;contador
	.db   0x0A									;constcont
	.db   0x0C									;fila
	.dw   ia_sys_behaviour_LeftOrRight					;behaviour
	.db   0x00									;auxiliar

plataforma_sumergido_template:
	.db	type_plataforma							;type
	.db	cmp_render | cmp_movable | cmp_colider | cmp_haveIA	;comp
	.db	0x00, 0x16								;x, y
	.db	0x01, 0x00								;vx, vy
	.db	Width16, Height16							;w, h
	.dw	_spr_hielo								;sprite
	.db	0x00, 0x70								;lastPtr  
	.db	0x00, 0x70								;lastPtr 2
	.db   0x05									;contador
	.db   0x0A									;constcont
	.db   0x0C									;fila
	.dw   ia_sys_behaviour_plataforma					;behaviour
	.db   0x80									;auxiliar

huron_template:
	.db	type_enemigo							;type
	.db	cmp_render | cmp_movable | cmp_colider | cmp_haveIA	;comp
	.db	0x00, 0x80								;x, y
	.db	0x01, 0x00								;vx, vy
	.db	Width11, Height16							;w, h
	.dw	_spr_huron_0							;sprite
	.db	0x00, 0x70								;lastPtr  
	.db	0x00, 0x70								;lastPtr 2
	.db   0x05									;contador
	.db   0x0A									;constcont
	.db   0x06									;fila
	.dw   ia_sys_behaviour_Guardian					;behaviour
	.db   0x00									;auxiliar

pocion_template:
	.db	type_item    							;type
	.db	cmp_render | cmp_colider 					;comp
	.db	0x10, 0xE0								;x, y
	.db	0x00, 0x00								;vx, vy
	.db	Width8, Height16							;w, h
	.dw	_spr_pocion       						;sprite
	.db	0x00, 0x70								;lastPtr  
	.db	0x00, 0x70								;lastPtr 2
	.db   0x00									;contador
	.db   0x00									;constcont
	.db   0x00									;fila
	.dw   ia_sys_behaviour_Pocion  					;behaviour
	.db   0x00									;auxiliar

reloj_template:
	.db	type_item    							;type
	.db	cmp_render | cmp_colider 					;comp
	.db	0x10, 0xE0								;x, y
	.db	0x00, 0x00								;vx, vy
	.db	Width8, Height16							;w, h
	.dw	_spr_reloj	      						;sprite
	.db	0x00, 0x70								;lastPtr  
	.db	0x00, 0x70								;lastPtr 2
	.db   0x00									;contador
	.db   0x00									;constcont
	.db   0x00									;fila
	.dw   ia_sys_behaviour_Reloj  					;behaviour
	.db   0x00									;auxiliar

portal_template:
	.db	type_item    							;type
	.db	cmp_render | cmp_colider 					;comp
	.db	0x10, 0xE0								;x, y
	.db	0x00, 0x00								;vx, vy
	.db	Width8, Height16							;w, h
	.dw	_spr_portal        						;sprite
	.db	0x00, 0x70								;lastPtr  
	.db	0x00, 0x70								;lastPtr 2
	.db   0x00									;contador
	.db   0x00									;constcont
	.db   0x00									;fila
	.dw   ia_sys_behaviour_Portal  					;behaviour
	.db   0x00									;auxiliar


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;template_man_cambiarColorHuron
;;cambiar color de los ojos de huron
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Input: a color
;;       b color flipeado
;;      ix direccion memoria huron
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Output:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Modified register: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
template_man_cambiarColorHuron:

	ld c, a
	ld a, e_vx(ix)
	cp #0x80
	jr c, cambiarColorFlip

      ;#4a rojo, #6a amarillo sin flipear
	ld iy, #_spr_huron_0
	ld 68(iy), c
	ld 101(iy), c

	ld iy, #_spr_huron_1
	ld 68(iy), c
	ld 101(iy), c

	ret

	cambiarColorFlip:
	;#85 rojo, #95 amarillo flipeando
	ld iy, #_spr_huron_0
	ld 74(iy), c
	ld 107(iy), c

	ld iy, #_spr_huron_1
	ld 74(iy), c
	ld 107(iy), c

	ret