;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of PENGUIN CROSS 
;;  Copyright (C) 2020 Francesc Bellido Delgado
;;  Copyright (C) 2020 David Mulero Pérez
;;  Copyright (C) 2020 Wei He
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "manager/state_man.h.s"
.include "system/render_sys.h.s"
.include "system/music_sys.h.s"
.include "manager/game_man.h.s"
.include "manager/menu_man.h.s"
.include "interrupt_sys.h.s"
.include "cpct_functions.h.s"


interrupt_cont: 
	.db 06

int_handler:

	push af
	push bc
	push de
	push hl
	push ix
	push iy

	ld a, (interrupt_cont)
	dec a
	cp #3
	jr z, _tres
	cp #0
	jr nz, _cont

	_zero:

		call state_man_getStatus
		cp #state_game
		jr nz, handler_salto
			call game_man_updateContadorTiempoInicio
			call game_man_update_time

	handler_salto:
	ld a, #6
	jr _cont

	_tres:
		push af
		call menu_man_getSoundOption
		dec a
		dec a
		jr z,tresNoSound
		call cpct_akp_musicPlay_asm ;cuidado se destruyen todos los registros en concreto ix
		call music_sys_actualizarTiempo
		call music_sys_actualizarEfecto

		tresNoSound:
		pop af

	_cont:
	ld (interrupt_cont), a

	pop iy
	pop ix
	pop hl
	pop de
	pop bc
	pop af

	ei 
	reti

set_int_handler:
	ld   hl, #0x38
	ld (hl), #0xC3
	inc hl
	ld (hl), #<int_handler
	inc hl
	ld (hl), #>int_handler
	inc hl
	ld (hl), #0xC9
	ret